/*
    client.c: Example program that will open a tcp connection and send/recv info
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <stdio.h>
#include <netdb.h>
#include <stdlib.h>
#include <tcpip.h>
#include <string.h>

struct host a;
struct host *h = &a;
char aux [2048];
int r;

int main (int argc, char *argv []) {
    if (argc < 3) {
	printf ("%s <ip or hostname> <port>\n", argv[0]);
	return (-1);
    }
    memset ((void *) (h), '\0', sizeof (struct host));
    /* 
    Let's try to get information of this host. We need it so we can
    call openconn () later
    */
    r = (int) gethostinfo (argv[1]);
    if (!r) {
	herror ("Error");
	exit (-1);
    }
    /*
    Copy the data from the return pointer to our own structure
    */
    memcpy ((void *) (h), (void *) (r), sizeof (struct host));
    printf ("Hostname: %s\nIP Address: %s\nNetwork number: %d\nPort number: %d\n", h->name, h->ip, h->sockin.sin_addr.s_addr, atoi (argv[2]));
    /*
    So now we have the host information. Let's open a tcp connection
    to the given port.
    */
    h->port = atoi (argv[2]);
    r = openconn (h, IPPROTO_TCP);
    if (r < 0) {
	herror ("Error");
	return (-1);
    }
    printf ("Connection number: %d\n", h->tcpconnects);
    /*
    Get the first burst of data (For example a pop server that gives
    a welcome message.
    */
    dataio (h, RECV);
    while (1) {
        printf ("%s", h->buffer);
	/* 
	Now let's zero the buffer, get a user input, send the data
	and receive the response.
	*/
        memset (h->buffer, '\0', sizeof (h->buffer));
        gets (h->buffer);
        sprintf (h->buffer, "%s\n", h->buffer);
        if (!(strncmp (h->buffer, "end", 3))) break;
        dataio (h, SENDRECV);
    };
    closeconn (h);
    printf ("Connection number: %d\n", h->tcpconnects);
    exit (0);
}