/*
    gethostinfo.c: Example of the use of the gethostinfo () function. 
    Part of EasyTcpIp library.
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <stdio.h>
#include <netdb.h>
#include <tcpip.h>

struct host *h;

int main (int argc, char *argv []) {
    if (argc < 2) {
	printf ("%s <ip or hostname>\n", argv[0]);
	return (-1);
    }
    h = gethostinfo (argv[1]);
    if (h) {
	printf ("Hostname: %s\nIP Address: <%s>\nNetwork number: <%d>\n", h->name, h->ip, h->sockin.sin_addr.s_addr);
	exit (0);
    } else {
	herror ("Error");
	exit (-1);
    }
}