/*
    server.c: Example program that will listen for a tcp connection and send/recv info
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <stdio.h>
#include <netdb.h>
#include <stdlib.h>
#include <tcpip.h>
#include <string.h>

struct host server;
struct host *s = &server;
struct host client;
struct host *c = &client;
char aux [2048];
int r;

int main (int argc, char *argv []) {
    if (argc < 2) {
	printf ("%s <port>\n", argv[0]);
	return (-1);
    }
    memset ((void *) (s), '\0', sizeof (struct host));
    memset ((void *) (c), '\0', sizeof (struct host));    
    /*
    Let's open a tcp server on the given port.
    */
    s->port = atoi (argv[1]);
    r = openserver (s, IPPROTO_TCP, 1);
    if (r) {
	herror ("Error");
	return (-1);
    }
    c = getclient (s);
    if (!c) {
        herror ("Error");
        return (-1);
    }
    memset ((void *) (c->buffer), '\0', sizeof (c->buffer));
    memset ((void *) (s->buffer), '\0', sizeof (s->buffer));    
    printf ("Connection from: %s <%s>\n", c->name, c->ip);
    sprintf (c->buffer, "Welcome to the server example. Type something.\n");
    dataio (c, SENDRECV);
    dataio (c, SEND);
    memset ((void *) (s->buffer), '\0', sizeof (s->buffer));    
    sprintf (c->buffer, "That's all. See ya ;).\n");
    dataio (c, SEND);
    closeconn (s);
    closeconn (c);
    exit (0);
}