/*
    gethostinfo.c: Will get vital info from the given host.
    Part of the EasyTcpIp library.
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <ctype.h>
#include "tcpip.h"

struct host *gethostinfo (char *name) {
    int r;
    struct host *h = &hst;
    struct hostent hstent;
    memset ((void *) (&hstent), '\0', sizeof (struct hostent));
    h->sockin.sin_family = AF_INET;
    if (isdigit (name[0])) {
	strncpy (h->ip, name, sizeof (h->ip));
	r = inet_aton (h->ip, &h->sockin.sin_addr);
	if (!r) return (0);
	r = (int) gethostbyaddr ((void *)(&h->sockin.sin_addr), sizeof (struct in_addr), AF_INET);
	if (!r) return (0);
	memcpy ((void *) (&hstent), (void *) (r), sizeof (struct hostent));
	strcpy (h->name, hstent.h_name);
	return (h);
    }
    if (isalpha (name[0])) {
	strncpy (h->name, name, sizeof (h->name));
	r = (int) gethostbyname ((void *)(h->name));	
	if (!r) return (0);
	memcpy ((void *) (&hstent), (void *) (r), sizeof (struct hostent));
	memcpy ((void *) (&h->sockin.sin_addr), (void *) (hstent.h_addr), sizeof (struct in_addr));
	strcpy (h->ip, inet_ntoa (h->sockin.sin_addr));
	if (!r) return (0);
	return (h);
    } 
return (0);
}