/*
    tcpip.h: Defines and all.
    Part of the EasyTcpIp library.
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <ctype.h>
#include <netinet/in.h>

#define MAJOR_VERSION = 0
#define MINOR_VERSION = 2
#define SEND 1
#define RECV 2
#define SENDRECV 3

struct host {
    char name [50];
    char ip [16];
    struct sockaddr_in sockin;
    int s;
    char protocol;
    int port;
    int tcpconnects;
    int udpconnects;
    char buffer [2048];
} hst;

struct host *gethostinfo (char *name);
int openserver (struct host *h, int protocol, int backlog);
struct host *getclient (struct host *h);
int openconn (struct host *h, int protocol);
int closeconn (struct host *h);
int dataio (struct host *h, char cmd);
